#!/usr/bin/perl -w

# Converts a amino acid model file from paml format to GeLL format
# Usage: convert.pl PAMLFILE GELLFILE

open(PAML,$ARGV[0]);
my @matrix;

for (my $i = 1; $i < 20; $i++)
{
	my $line = <PAML>;
	my @parts = split(/\s+/,$line);
	
	for (my $j = 0; $j < scalar(@parts); $j++)
	{
		$matrix[$i][$j] = $parts[$j];
		$matrix[$j][$i] = $parts[$j];
	}
}

my $line = <PAML>;
$line = <PAML>;

my @freq = split(/\s+/,$line);

open(GELL,">" . $ARGV[1]);

print GELL "20\n";
print GELL "\n";
print GELL "A\tR\tN\tD\tC\tQ\tE\tG\tH\tI\tL\tK\tM\tF\tP\tS\tT\tW\tY\tV\n";
print GELL "\n";

for ($i = 0; $i < 20; $i++)
{
	if ($i == 0)
	{
		$line = "-";
	}
	else
	{
		my $rate = $matrix[$i][0] * $freq[0];
		$line = $rate;
	}
	for ($j = 1; $j < 20; $j++)
	{
		if ($i == $j)
		{
			$line = $line . "\t-";
		}
		else
		{
			my $rate = $matrix[$i][$j] * $freq[$j];
			$line = $line . "\t" . $rate;
		}
	}
	print GELL $line . "\n";
}

print GELL "\n";

my $fl = $freq[0];
for (my $i = 1; $i < 20; $i ++)
{
	$fl = $fl . "\t" . $freq[$i];
}
print GELL $fl . "\n";

close(GELL);